/*
Rewards API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package rewardsapi

import (
	"encoding/json"
	"time"
)

// checks if the CouponingConfigDto type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CouponingConfigDto{}

// CouponingConfigDto struct for CouponingConfigDto
type CouponingConfigDto struct {
	Id string `json:"id"`
	Name string `json:"name"`
	Description *string `json:"description,omitempty"`
	OrganizationId string `json:"organization_id"`
	CodeType int32 `json:"code_type"`
	GenericCode *string `json:"generic_code,omitempty"`
	StartAt *time.Time `json:"start_at,omitempty"`
	EndAt *time.Time `json:"end_at,omitempty"`
	MaxRedemptions *int32 `json:"max_redemptions,omitempty"`
	ExternalName *string `json:"external_name,omitempty"`
	// minutes
	CouponExpiresAfter *int32 `json:"coupon_expires_after,omitempty"`
	Metrics []CouponingConfigDtoMetricsInner `json:"metrics"`
	ImportMetadata []CouponingConfigDtoImportMetadataInner `json:"import_metadata"`
}

// NewCouponingConfigDto instantiates a new CouponingConfigDto object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCouponingConfigDto(id string, name string, organizationId string, codeType int32, metrics []CouponingConfigDtoMetricsInner, importMetadata []CouponingConfigDtoImportMetadataInner) *CouponingConfigDto {
	this := CouponingConfigDto{}
	this.Id = id
	this.Name = name
	this.OrganizationId = organizationId
	this.CodeType = codeType
	this.Metrics = metrics
	this.ImportMetadata = importMetadata
	return &this
}

// NewCouponingConfigDtoWithDefaults instantiates a new CouponingConfigDto object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCouponingConfigDtoWithDefaults() *CouponingConfigDto {
	this := CouponingConfigDto{}
	return &this
}

// GetId returns the Id field value
func (o *CouponingConfigDto) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *CouponingConfigDto) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *CouponingConfigDto) SetId(v string) {
	o.Id = v
}

// GetName returns the Name field value
func (o *CouponingConfigDto) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *CouponingConfigDto) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *CouponingConfigDto) SetName(v string) {
	o.Name = v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *CouponingConfigDto) GetDescription() string {
	if o == nil || IsNil(o.Description) {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CouponingConfigDto) GetDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.Description) {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *CouponingConfigDto) HasDescription() bool {
	if o != nil && !IsNil(o.Description) {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *CouponingConfigDto) SetDescription(v string) {
	o.Description = &v
}

// GetOrganizationId returns the OrganizationId field value
func (o *CouponingConfigDto) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *CouponingConfigDto) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *CouponingConfigDto) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetCodeType returns the CodeType field value
func (o *CouponingConfigDto) GetCodeType() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.CodeType
}

// GetCodeTypeOk returns a tuple with the CodeType field value
// and a boolean to check if the value has been set.
func (o *CouponingConfigDto) GetCodeTypeOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CodeType, true
}

// SetCodeType sets field value
func (o *CouponingConfigDto) SetCodeType(v int32) {
	o.CodeType = v
}

// GetGenericCode returns the GenericCode field value if set, zero value otherwise.
func (o *CouponingConfigDto) GetGenericCode() string {
	if o == nil || IsNil(o.GenericCode) {
		var ret string
		return ret
	}
	return *o.GenericCode
}

// GetGenericCodeOk returns a tuple with the GenericCode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CouponingConfigDto) GetGenericCodeOk() (*string, bool) {
	if o == nil || IsNil(o.GenericCode) {
		return nil, false
	}
	return o.GenericCode, true
}

// HasGenericCode returns a boolean if a field has been set.
func (o *CouponingConfigDto) HasGenericCode() bool {
	if o != nil && !IsNil(o.GenericCode) {
		return true
	}

	return false
}

// SetGenericCode gets a reference to the given string and assigns it to the GenericCode field.
func (o *CouponingConfigDto) SetGenericCode(v string) {
	o.GenericCode = &v
}

// GetStartAt returns the StartAt field value if set, zero value otherwise.
func (o *CouponingConfigDto) GetStartAt() time.Time {
	if o == nil || IsNil(o.StartAt) {
		var ret time.Time
		return ret
	}
	return *o.StartAt
}

// GetStartAtOk returns a tuple with the StartAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CouponingConfigDto) GetStartAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.StartAt) {
		return nil, false
	}
	return o.StartAt, true
}

// HasStartAt returns a boolean if a field has been set.
func (o *CouponingConfigDto) HasStartAt() bool {
	if o != nil && !IsNil(o.StartAt) {
		return true
	}

	return false
}

// SetStartAt gets a reference to the given time.Time and assigns it to the StartAt field.
func (o *CouponingConfigDto) SetStartAt(v time.Time) {
	o.StartAt = &v
}

// GetEndAt returns the EndAt field value if set, zero value otherwise.
func (o *CouponingConfigDto) GetEndAt() time.Time {
	if o == nil || IsNil(o.EndAt) {
		var ret time.Time
		return ret
	}
	return *o.EndAt
}

// GetEndAtOk returns a tuple with the EndAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CouponingConfigDto) GetEndAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.EndAt) {
		return nil, false
	}
	return o.EndAt, true
}

// HasEndAt returns a boolean if a field has been set.
func (o *CouponingConfigDto) HasEndAt() bool {
	if o != nil && !IsNil(o.EndAt) {
		return true
	}

	return false
}

// SetEndAt gets a reference to the given time.Time and assigns it to the EndAt field.
func (o *CouponingConfigDto) SetEndAt(v time.Time) {
	o.EndAt = &v
}

// GetMaxRedemptions returns the MaxRedemptions field value if set, zero value otherwise.
func (o *CouponingConfigDto) GetMaxRedemptions() int32 {
	if o == nil || IsNil(o.MaxRedemptions) {
		var ret int32
		return ret
	}
	return *o.MaxRedemptions
}

// GetMaxRedemptionsOk returns a tuple with the MaxRedemptions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CouponingConfigDto) GetMaxRedemptionsOk() (*int32, bool) {
	if o == nil || IsNil(o.MaxRedemptions) {
		return nil, false
	}
	return o.MaxRedemptions, true
}

// HasMaxRedemptions returns a boolean if a field has been set.
func (o *CouponingConfigDto) HasMaxRedemptions() bool {
	if o != nil && !IsNil(o.MaxRedemptions) {
		return true
	}

	return false
}

// SetMaxRedemptions gets a reference to the given int32 and assigns it to the MaxRedemptions field.
func (o *CouponingConfigDto) SetMaxRedemptions(v int32) {
	o.MaxRedemptions = &v
}

// GetExternalName returns the ExternalName field value if set, zero value otherwise.
func (o *CouponingConfigDto) GetExternalName() string {
	if o == nil || IsNil(o.ExternalName) {
		var ret string
		return ret
	}
	return *o.ExternalName
}

// GetExternalNameOk returns a tuple with the ExternalName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CouponingConfigDto) GetExternalNameOk() (*string, bool) {
	if o == nil || IsNil(o.ExternalName) {
		return nil, false
	}
	return o.ExternalName, true
}

// HasExternalName returns a boolean if a field has been set.
func (o *CouponingConfigDto) HasExternalName() bool {
	if o != nil && !IsNil(o.ExternalName) {
		return true
	}

	return false
}

// SetExternalName gets a reference to the given string and assigns it to the ExternalName field.
func (o *CouponingConfigDto) SetExternalName(v string) {
	o.ExternalName = &v
}

// GetCouponExpiresAfter returns the CouponExpiresAfter field value if set, zero value otherwise.
func (o *CouponingConfigDto) GetCouponExpiresAfter() int32 {
	if o == nil || IsNil(o.CouponExpiresAfter) {
		var ret int32
		return ret
	}
	return *o.CouponExpiresAfter
}

// GetCouponExpiresAfterOk returns a tuple with the CouponExpiresAfter field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CouponingConfigDto) GetCouponExpiresAfterOk() (*int32, bool) {
	if o == nil || IsNil(o.CouponExpiresAfter) {
		return nil, false
	}
	return o.CouponExpiresAfter, true
}

// HasCouponExpiresAfter returns a boolean if a field has been set.
func (o *CouponingConfigDto) HasCouponExpiresAfter() bool {
	if o != nil && !IsNil(o.CouponExpiresAfter) {
		return true
	}

	return false
}

// SetCouponExpiresAfter gets a reference to the given int32 and assigns it to the CouponExpiresAfter field.
func (o *CouponingConfigDto) SetCouponExpiresAfter(v int32) {
	o.CouponExpiresAfter = &v
}

// GetMetrics returns the Metrics field value
func (o *CouponingConfigDto) GetMetrics() []CouponingConfigDtoMetricsInner {
	if o == nil {
		var ret []CouponingConfigDtoMetricsInner
		return ret
	}

	return o.Metrics
}

// GetMetricsOk returns a tuple with the Metrics field value
// and a boolean to check if the value has been set.
func (o *CouponingConfigDto) GetMetricsOk() ([]CouponingConfigDtoMetricsInner, bool) {
	if o == nil {
		return nil, false
	}
	return o.Metrics, true
}

// SetMetrics sets field value
func (o *CouponingConfigDto) SetMetrics(v []CouponingConfigDtoMetricsInner) {
	o.Metrics = v
}

// GetImportMetadata returns the ImportMetadata field value
func (o *CouponingConfigDto) GetImportMetadata() []CouponingConfigDtoImportMetadataInner {
	if o == nil {
		var ret []CouponingConfigDtoImportMetadataInner
		return ret
	}

	return o.ImportMetadata
}

// GetImportMetadataOk returns a tuple with the ImportMetadata field value
// and a boolean to check if the value has been set.
func (o *CouponingConfigDto) GetImportMetadataOk() ([]CouponingConfigDtoImportMetadataInner, bool) {
	if o == nil {
		return nil, false
	}
	return o.ImportMetadata, true
}

// SetImportMetadata sets field value
func (o *CouponingConfigDto) SetImportMetadata(v []CouponingConfigDtoImportMetadataInner) {
	o.ImportMetadata = v
}

func (o CouponingConfigDto) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CouponingConfigDto) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["name"] = o.Name
	if !IsNil(o.Description) {
		toSerialize["description"] = o.Description
	}
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["code_type"] = o.CodeType
	if !IsNil(o.GenericCode) {
		toSerialize["generic_code"] = o.GenericCode
	}
	if !IsNil(o.StartAt) {
		toSerialize["start_at"] = o.StartAt
	}
	if !IsNil(o.EndAt) {
		toSerialize["end_at"] = o.EndAt
	}
	if !IsNil(o.MaxRedemptions) {
		toSerialize["max_redemptions"] = o.MaxRedemptions
	}
	if !IsNil(o.ExternalName) {
		toSerialize["external_name"] = o.ExternalName
	}
	if !IsNil(o.CouponExpiresAfter) {
		toSerialize["coupon_expires_after"] = o.CouponExpiresAfter
	}
	toSerialize["metrics"] = o.Metrics
	toSerialize["import_metadata"] = o.ImportMetadata
	return toSerialize, nil
}

type NullableCouponingConfigDto struct {
	value *CouponingConfigDto
	isSet bool
}

func (v NullableCouponingConfigDto) Get() *CouponingConfigDto {
	return v.value
}

func (v *NullableCouponingConfigDto) Set(val *CouponingConfigDto) {
	v.value = val
	v.isSet = true
}

func (v NullableCouponingConfigDto) IsSet() bool {
	return v.isSet
}

func (v *NullableCouponingConfigDto) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCouponingConfigDto(val *CouponingConfigDto) *NullableCouponingConfigDto {
	return &NullableCouponingConfigDto{value: val, isSet: true}
}

func (v NullableCouponingConfigDto) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCouponingConfigDto) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


